package videowrapper;

import com.exercise.AndroidVideoCapture.MyCameraSurfaceView;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.TextViewWrapper;
import anywheresoftware.b4a.BA.Events;


import android.view.View;
import android.view.Gravity; 


import java.io.IOException;

import android.app.Activity;
import android.content.Context;
import android.hardware.Camera;
import android.hardware.Camera.Parameters;
import android.hardware.Camera.CameraInfo;
import android.media.CamcorderProfile;
import android.media.MediaRecorder;
import android.os.Bundle;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.Toast;

import android.content.Intent;
import android.content.IntentFilter;
import android.net.Uri;
import android.os.Environment;
import java.lang.Thread;
import android.os.Handler;

import java.text.SimpleDateFormat;
import java.util.Locale;

import java.util.List; 

import java.io.File;
import java.io.FileOutputStream;


@Events(values={"flash_toggled(flashOnOrOff As Boolean)", "max_duration_reached(maxdurationreached As Boolean)", "max_file_size_reached(maxsizereached As Boolean)"})
@Author("Original project by: Andr.oid Eric, Adapted, modified, and wrapped by: Johan Schoeman")
@Version(1.00f)
@ShortName("AndroidVideoCapture")
//@DependsOn(values={"android-support-annotations"})
public class videoWrapper extends ViewWrapper<MyCameraSurfaceView> implements DesignerCustomView {


	private BA ba;
	private String eventName;
        private MyCameraSurfaceView cv;
	private Camera myCamera;
        private MediaRecorder mediaRecorder;
	private SurfaceHolder surfaceHolder;
	private boolean recording = false;
        private boolean isFlashOn = false;
        private int currentZoomLevel = 0, maxZoomLevel = 0;
        private Handler mHandler = new Handler();


        public int QUALITY_1080P = 6;                                  //1920 x 1080
        public int QUALITY_2160P = 8;                                  //3840 x 2160
        public int QUALITY_480P = 4;                                   //720 x 480
        public int QUALITY_720P = 5;                                   //1280 x 720
        public int QUALITY_CIF = 3;                                    //352 x 288
        public int QUALITY_HIGH = 1;                                   //highest available resolution
//      public int QUALITY_HIGH_SPEED_1080P = 2004;
//      public int QUALITY_HIGH_SPEED_2160P = 2005; 
//      public int QUALITY_HIGH_SPEED_480P = 2002; 
//      public int QUALITY_HIGH_SPEED_720P = 2003;      
//      public int QUALITY_HIGH_SPEED_HIGH = 2001;     
//      public int QUALITY_HIGH_SPEED_LOW = 2000;    
        public int QUALITY_LOW = 0;                                    //lowest available resolution
        public int QUALITY_QCIF = 2;                                   //176 x 144
        public int QUALITY_QVGA = 7;                                   //320x240

        private int qualityvalue = 0;  
        public int CAMERA_FRONT = 1;
        public int CAMERA_BACK = 0;

        private String[] qualitylist = {"", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
        private int cntr = 0;

 

	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
                myCamera = getCameraInstance();
                if(myCamera == null){
        	   Toast.makeText(ba.applicationContext, 
        			"Fail to get Camera", 
        			Toast.LENGTH_LONG).show();
                }            
		cv = new MyCameraSurfaceView(ba.context, myCamera);
                this.setObject(cv);
                recording = false;
//              addListener();
                addListener2();
 	}



//    @Hide
//    public void addListener(){

//        cv.setCallback(new Wheel.Callback() {
//            @Override
//            public void value_changed() {

//              if (ba.subExists(eventName + "_value_changed")) {
//                ba.raiseEvent2(ba, false, eventName + "_value_changed", true, new Object[]{retval});
//              }
//            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_click")) {
//                ba.raiseEvent2(ba, false, eventName + "_click", true, new Object[0]);
//              }
//            }


//        });
//    }


      @Hide
      public void addListener2(){
        cv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
              if ((recording == true) && (isFlashOn == false)) {
                   isFlashOn = true;
                   Parameters parameters = myCamera.getParameters();
                   parameters.setFlashMode(Parameters.FLASH_MODE_TORCH);
                   myCamera.setParameters(parameters);
              } else {
                if ((recording == true) && (isFlashOn == true)) {
                     isFlashOn = false;
                     Parameters parameters = myCamera.getParameters();
                     parameters.setFlashMode(Parameters.FLASH_MODE_OFF);
                     myCamera.setParameters(parameters);
                }
              }
              if (ba.subExists(eventName + "_flash_toggled")) {
                ba.raiseEvent2(ba, false, eventName + "_flash_toggled", true, new Object[]{isFlashOn});
              }
            }
        });
      }

//    public void addImage(String draw) {
//		 int DrawableID = BA.applicationContext.getResources().getIdentifier(draw, "drawable", BA.packageName);
//               cv.setForeground(DrawableID);
//		 Drawable drawable = BA.applicationContext.getResources().getDrawable(DrawableID);
//               cv.setForeground(drawable); 
//    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}


    public void setStartStopRecording() {
		if(recording){
                  recording = false; 
                  // stop recording and release camera
                  mediaRecorder.stop();  // stop the recording
                  releaseMediaRecorder(); // release the MediaRecorder object
                
                  //Exit after saved
                  releaseCamera();

		}else{
				
		  //Release Camera before MediaRecorder start
		  releaseCamera();
				
		  if(!prepareMediaRecorder()){
		       	Toast.makeText(ba.applicationContext, "Fail in prepareMediaRecorder()!\n - Ended -", Toast.LENGTH_LONG).show();
		       	releaseCamera();
		  }

                  mHandler.postDelayed(new Runnable() {
                      public void run() {
//                          doStuff();
                      }
                  }, 2000);

                  mediaRecorder.start();
		  recording = true;


                 Parameters parameters = myCamera.getParameters();
                 parameters.setFocusMode(Camera.Parameters.FOCUS_MODE_CONTINUOUS_VIDEO);
                 myCamera.setParameters(parameters);

		}
   }


    private Camera getCameraInstance(){
		// TODO Auto-generated method stub
        Camera c = null;
        try {    
            c = Camera.open(ctu); // attempt to get a Camera instance

            Camera.Parameters cameraParams = c.getParameters();
//          cameraParams.set( "cam_mode", 1 ); 
            List<Camera.Size> supportedPreviewSizes = cameraParams.getSupportedPreviewSizes();
            cntr = 0;
            int cwidth = 0;
            int cheight = 0;
            for (int i = 0; i < supportedPreviewSizes.size(); i++) {
               Camera.Size size = supportedPreviewSizes.get(i);
               cwidth = size.width;
               cheight = size.height;
               supportedQualityList(cwidth, cheight);
//             qualitylist[cntr] = cwidth + "," + cheight;
//             cntr = cntr + 1;
            }
        }
        catch (Exception e){
            // Camera is not available (in use or does not exist)
            c = Camera.open(); // attempt to get a Camera instance

            Camera.Parameters cameraParams = c.getParameters();
            List<Camera.Size> supportedPreviewSizes = cameraParams.getSupportedPreviewSizes();
            cntr = 0;
            int cwidth = 0;
            int cheight = 0;
            for (int i = 0; i < supportedPreviewSizes.size(); i++) {
               Camera.Size size = supportedPreviewSizes.get(i);
               cwidth = size.width;
               cheight = size.height;
               supportedQualityList(cwidth, cheight);
            }
        }
        return c; // returns null if camera is unavailable
    }

	
	private boolean prepareMediaRecorder(){
	    myCamera = getCameraInstance();
            

	    mediaRecorder = new MediaRecorder();

            mediaRecorder.setOnInfoListener(infoListener);


            myCamera.setDisplayOrientation(0);


            mediaRecorder.setOrientationHint(0);           //this turns the thumbnail to the correct orientation but the video is still turned 90 degrees.


	    myCamera.unlock();
	    mediaRecorder.setCamera(myCamera);

	    mediaRecorder.setAudioSource(MediaRecorder.AudioSource.CAMCORDER);
	    mediaRecorder.setVideoSource(MediaRecorder.VideoSource.CAMERA);

	    mediaRecorder.setProfile(CamcorderProfile.get(qualityvalue));                 //original code 



            File folder = new File(Environment.getExternalStorageDirectory(), "/" + foldername);
            if (!folder.exists()) {
                folder.mkdirs();
            }

     
            java.util.Date date = new java.util.Date();
            String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss", Locale.ENGLISH) .format(date.getTime());


	    mediaRecorder.setOutputFile("/sdcard/" + foldername + "/" + videoname + "_" + timeStamp + ".mp4");
//          mediaRecorder.setOutputFile(configFilePath + videoname + "_" + timeStamp + ".mp4");

            mediaRecorder.setMaxDuration(maximumduration); // Set max duration milliseconds
            mediaRecorder.setMaxFileSize(maximumfilesize); // Set max file size 5M

	    mediaRecorder.setPreviewDisplay(cv.getHolder().getSurface());

	    try {
	        mediaRecorder.prepare();
	    } catch (IllegalStateException e) {
                BA.Log("IllegalStateException " + e.toString());
	        releaseMediaRecorder();
	        return false;
	    } catch (IOException e) {
                BA.Log("IOException " + e.toString());
	        releaseMediaRecorder();
	        return false;
	    }
	    return true;
		
	}

    public void releaseResources() {
        releaseMediaRecorder();       // if you are using MediaRecorder, release it first
        releaseCamera();              // release the camera immediately on pause event
    }

    private void releaseMediaRecorder(){
        if (mediaRecorder != null) {
            mediaRecorder.reset();   // clear recorder configuration
            mediaRecorder.release(); // release the recorder object
            mediaRecorder = null;
            myCamera.lock();           // lock camera for later use
        }
    }

    private void releaseCamera(){
        if (myCamera != null){
            myCamera.release();        // release the camera for other applications
            myCamera = null;
        }
    }

    private int maximumduration = 60000;                 //milliseconds
    public void setMaximimDuration(int maximumduration) {
         this.maximumduration = maximumduration;
    }

    private long maximumfilesize = 5000000;                 //bytes
    public void setMaximumFileSize(long maximumfilesize) {
         this.maximumfilesize = maximumfilesize;
    }

    public void toggleFlash() {

              if ((recording == true) && (isFlashOn == false)) {
                   isFlashOn = true;
                   Parameters parameters = myCamera.getParameters();
                   parameters.setFlashMode(Parameters.FLASH_MODE_TORCH);
                   parameters.setFocusMode(Camera.Parameters.FOCUS_MODE_CONTINUOUS_VIDEO);
                   myCamera.setParameters(parameters);
              } else {
                if ((recording == true) && (isFlashOn == true)) {
                     isFlashOn = false;
                     Parameters parameters = myCamera.getParameters();
                     parameters.setFlashMode(Parameters.FLASH_MODE_OFF);
                     parameters.setFocusMode(Camera.Parameters.FOCUS_MODE_CONTINUOUS_VIDEO);
                     myCamera.setParameters(parameters);
                }
              }
              if (ba.subExists(eventName + "_flash_toggled")) {
                ba.raiseEvent2(ba, false, eventName + "_flash_toggled", true, new Object[]{isFlashOn});
              }
    }

    public void ZoomIn() {
      if (myCamera != null) {
        Parameters parameters = myCamera.getParameters();
        if(parameters.isZoomSupported()){    
           maxZoomLevel = parameters.getMaxZoom();
//         BA.Log("Max Zoom Level = " + maxZoomLevel);
           if(currentZoomLevel < maxZoomLevel){
              currentZoomLevel++;
              parameters.setZoom(currentZoomLevel);
              myCamera.setParameters(parameters);
           }
        }
      }
    }

    public void ZoomOut() {
      if (myCamera != null) {
        Parameters parameters = myCamera.getParameters();
        if(parameters.isZoomSupported()){    
            if(currentZoomLevel > 0){
                currentZoomLevel--;
                parameters.setZoom(currentZoomLevel);
                myCamera.setParameters(parameters);
            }
        }
      }
    }

    public void setZoomWithSlider(int slidervalue) {
      if (myCamera != null) {
        Parameters parameters = myCamera.getParameters();
        if(parameters.isZoomSupported()){    
           maxZoomLevel = parameters.getMaxZoom();
           if(slidervalue < maxZoomLevel){
              parameters.setZoom(slidervalue);
              myCamera.setParameters(parameters);
           }
        }
      }
    }

    private String videoname = "";
    public void setVideoName (String videoname) {
       this.videoname = videoname;
    }

    public void setVideoQuality (int qualityvalue) {
        this.qualityvalue = qualityvalue;
    }

    private MediaRecorder.OnInfoListener infoListener = new MediaRecorder.OnInfoListener() {
        @Override
        public void onInfo(MediaRecorder mr, int what, int extra) {
            if (what == 801) {
              if (stm == true) {
                Toast.makeText(ba.applicationContext, mfsrtm, Toast.LENGTH_LONG).show();
              }
                if (ba.subExists(eventName + "_max_file_size_reached")) {
                   boolean maxfilesizereached = true;
                   ba.raiseEvent2(ba, false, eventName + "_max_file_size_reached", true, new Object[]{maxfilesizereached});            
                }
            }

            if (what == 800) {
              if (stm == true) {
                Toast.makeText(ba.applicationContext, mdrtm, Toast.LENGTH_LONG).show();
              }
                if (ba.subExists(eventName + "_max_duration_reached")) {
                   boolean maxdurationreached = true;
                   ba.raiseEvent2(ba, false, eventName + "_max_duration_reached", true, new Object[]{maxdurationreached});            
                }
            }
            if (scomsd == true) {
               setStartStopRecording();
            }
        }
    };

    private boolean stm = true;
    public void setShowToastMessages(boolean stm) {
        this.stm = stm;
    }

    private boolean scomsd = false;
    public void setStopCameraOnMaxSizeDuration(boolean scomsd) {
        this.scomsd = scomsd;
    }

    private int ctu = 0;
    public void setCameraToUse (int ctu) {
      this.ctu = ctu;
    }


    private String mdrtm = "";
    public void setMaximumDurationReachedToastMessage(String mdrtm) {
        this.mdrtm = mdrtm;
    }

    private String mfsrtm = "";
    public void setMaximumFileSizeReachedToastMessage(String mfsrtm) {
        this. mfsrtm = mfsrtm;
    }


    private String foldername = "Videos";
    public void setVideoFolderName(String foldername) {
       this.foldername = foldername;
    }

    private void supportedQualityList(int width, int height) {
         if (width == 1920) {
             qualitylist[cntr] = "QUALITY_1080P";
             cntr = cntr + 1;
         }
         if (width == 3840) {
             qualitylist[cntr] = "QUALITY_2160P";
             cntr = cntr + 1;
         } 
         if (width == 720) {
             qualitylist[cntr] = "QUALITY_480P";
             cntr = cntr + 1;
         } 
         if (width == 1280) {
             qualitylist[cntr] = "QUALITY_720P";
             cntr = cntr + 1;
         } 
         if (width == 352) {
             qualitylist[cntr] = "QUALITY_CIF";
             cntr = cntr + 1;
         }           
         if (width == 176) {
             qualitylist[cntr] = "QUALITY_QCIF";
             cntr = cntr + 1;
         } 
         if (width == 320) {
             qualitylist[cntr] = "QUALITY_QVGA";
             cntr = cntr + 1;    
         } 
         

    }

    
    public String[] getQualitySupportedList() {
         qualitylist[cntr] = "QUALITY_LOW";
         qualitylist[cntr + 1] = "QUALITY_HIGH";
         return qualitylist;
    }

  
}    //end of class













